/*Realizzato da Andrea Nazzaro - febbraio 2000
    per trovare altri listati visita il sito
       http://web.tiscalinet.it/nazhome
*/

/*
  Il programma  un piccolo viewer di file PCX
  per DOS. Per avere informazioni sul  formato
  PCX visitate il mio sito.
*/


#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <io.h>

#define G_MODE13	0x13	/*modalit 256 colori 320x200*/
#define G_TEXT		0x03    /*modalit testo 80x25*/
#define RUNCODE		0xC0
#define	RUNLENGHT	0x3F

void Graphics_Mode(int mode);   /*imposta modalit grafica o di testo*/
void Leggi_Pcx(FILE *pf,int x); /*legge immagine e palette*/
void Write_Pixel(int x,int y,int color);  /*disegna un pixel*/

unsigned char far *video_buffer=(unsigned char far*)0xA0000000L;
unsigned char palette[768];

struct PcxHeader{
	char manufacturer;	/*sempre 10*/
	char versione;		/*5 per file a 256 colori*/
	char encoding;		/*settato su 1*/
	char bits_per_pixel;	/*8 per un'immagine a 256 colori*/
	int xmin,ymin;		/*coordinate*/
	int xmax,ymax;		/*coordinate*/
	int hres;		/*risoluzione orizzontale*/
	int vres;		/*risoluzione verticale*/
	char palette16[48];	/*EGA palette*/
	char riservato;		/*riservato per usi futuri*/
	char color_planes;	/*color planes*/
	int bytes_per_linea;	/*numero di byte in una linea di pixel*/
	int palette_type;	/*2 per palette a colori*/
	char riempi[58];	/*serve solo a riempire la struttura*/
	}header;

main(int argc,char *argv[])
{
FILE *pf;
int X;
if(argc<2){
		printf("Uso: h_pcx nomefile.pcx\n");
		exit(0);
		}
if((pf=fopen(argv[1],"rb"))==NULL){  /*apre il file per la lettura*/
						printf("Impossibile aprire il file %s.\n",argv[1]);
						exit(0);
						}

fread(&header,1,sizeof(header),pf);	/*legge l'header*/
X=header.xmax-header.xmin+1;
Graphics_Mode(G_MODE13);
Leggi_Pcx(pf,X);
getch();				/*attende che venga premuto un tasto*/
Graphics_Mode(G_TEXT);
fclose(pf);			        /*chiude il file*/
}

void Graphics_Mode(int Mode)
{
union REGS inp,out;
inp.h.ah=0;
inp.h.al=(unsigned char)Mode;
int86(0x10,&inp,&out);
}

void Leggi_Pcx(FILE *pf,int x)
{
unsigned char c;
long lun,k=0L;
int n,xp=0,yp=0;
lun=filelength(fileno(pf))-sizeof(header)-768;
while(k<lun){
	       c=getc(pf);
	       k++;
	       if((c&RUNCODE)==RUNCODE){
					  n=(int)(c&RUNLENGHT);
					  c=getc(pf);
					  k++;
					  while(n--){
							Write_Pixel(xp,yp,c);
							xp++;
							if(xp>=x){
								  xp=0;yp++;
									}
							}
					  }
		else {
			Write_Pixel(xp,yp,c);
			xp++;
			if(xp>=x){
				xp=0;yp++;
				}
			}
		  }
fseek(pf,-768L,SEEK_END);
read(fileno(pf),palette,768);
for(n=0;n<768;n++)palette[n]=palette[n]>>2;	/*legge le palette*/
_AX=0x1012;
_BX=0;
_CX=256;
_ES=FP_SEG(palette);
_DX=FP_OFF(palette);
geninterrupt(0x10);
}

void Write_Pixel(int x,int y,int color)
{
video_buffer[((y<<8)+(y<<6))+x]=(unsigned char)color;
}